﻿//////////////////////////////////////////////
// ShaderInstanceMemorySlot.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class ShaderInstanceCustomSlot ;
}

/// Includes ---------------------------------
	
// nkGraphics
#include "ShaderMemorySlot.h"

#include "../../Dll/DllDefines.h"

/// Class ------------------------------------
	
namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT ShaderInstanceMemorySlot : public ShaderMemorySlot
	{
		public :

			// Données possibles
			enum class DATA_TYPE
			{
				UNKNOWN = 0,
				// Transformations
				WORLD_MATRIX,
				// Custom
				CUSTOM
			} ;

		protected :
		
			// Attributs
			// Données s'il faut
			void* _data ;
			// Taille données
			unsigned int _dataSize ;

			// Données active
			DATA_TYPE _type ;

		protected :

			// Functions
			// Data erasure
			void _deleteData () ;
		
		public :
		
			// Constructeur, destructeur
			ShaderInstanceMemorySlot () ;
			virtual ~ShaderInstanceMemorySlot () ;

			// Getters
			DATA_TYPE getType () const ;
			virtual unsigned int getDataSize () const ;
			virtual const char* getDataTypeAsString () const override ;

			// Setters
			void setAsWorldMatrix () ;
			void setAsCustom (ShaderInstanceCustomSlot* slot) ;

			// Import / export
			virtual void exportClassToTree (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}