﻿//////////////////////////////////////////////
// GlobalTimer.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

typedef unsigned long DWORD ;

/// Includes ---------------------------------

// nkGraphics
#include "../Dll/DllDefines.h"

/// Class ------------------------------------
	
namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT GlobalTimer
	{
		private :
		
			// Attributs
			// Notre dernier temps
			DWORD _lastFrameTime ;
			// Dernier delta
			DWORD _lastDeltaTime ;

			// Pour donnees shaders par exemple
			DWORD _currentModuloTime ;
			DWORD _modulo ;
			bool _loopedSinceLastTime ;
		
		public :

			// Constructeur, destructeur
			GlobalTimer () ;
			~GlobalTimer () ;

			// Setters
			void setModuloTime (DWORD moduloTime) ;
		
			// Le temps depuis la dernière frame
			void updateFrameTime () ;
			unsigned long getDeltaTime () const ;
			unsigned long getFrameTime () const ;

			// Pour le modulo
			unsigned long getCurrentModuloTime () const ;
			unsigned long getCurrentModulo () const ;
			bool getLoopedSinceLastTime () const ;

			// Getters pour des données actuelles
			int getCurrentYear () ;
			int getCurrentMonth () ;
			int getCurrentDay () ;
			int getCurrentHour () ;
			int getCurrentMin () ;
			int getCurrentSec () ;
	} ;
}