﻿//////////////////////////////////////////////
// ContentLoader.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkExport
{
	class Exportable ;
	class Node ;
}

namespace nkWinUi
{
	class Component ;
	class Layout ;
}

/// Includes ---------------------------------

// nkWinUi
#include "../Dll/DllDefines.h"

// nkExport
#include <NilkinsExport/Exporter/ExporterLoadResult.h>

// Standards
#include <string_view>

/// Class ------------------------------------

namespace nkWinUi
{	
	class DLL_WINUI_EXPORT ContentLoader final
	{
		private :
		
			// Constructeur, destructeur
			ContentLoader() ;
			~ContentLoader() ;
		
		public :

			// Fonctions pratiques
			static nkExport::ExporterLoadResult inputData (const std::string_view& filePath) ;
			static nkExport::ExporterLoadResult inputDataSources (const std::string_view& sources) ;
			static bool outputData (const std::string_view& content, const std::string_view& path) ;

			// Save
			static bool saveObjectDeclaration (nkExport::Exportable* object, const std::string_view& pathFromData) ;

			// Load
			// Component solitaire
			static Component* loadComponentDeclaration (const char* pathFromData) ;
			static Component* processComponentSources (const char* sources) ;
			static Component* processComponentTree (nkExport::Node* tree) ;
			// Layout solitaire
			static Layout* loadLayoutDeclaration (const char* pathFromData) ;
			static Layout* processLayoutSources (const char* sources) ;
			static Layout* processLayoutTree (nkExport::Node* tree) ;
			// Interface mixant les deux
			static Component* loadInterfaceDeclaration (const char* pathFromData) ;
			static Component* processInterfaceSources (const char* sources) ;
			static Component* processInterfaceTree (nkExport::Node* tree) ;
	} ;
}