﻿//////////////////////////////////////////////
// Theme.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkWinUi
#include "../Dll/DllDefines.h"

#include "Color.h"

// Standards
#include <string>

/// Internals --------------------------------

namespace nkWinUi
{
	struct DLL_WINUI_EXPORT ThemeColors
	{
		// Enabled
		// Couleur primaire
		Color _primaryColor ;
		// Secondaire
		Color _secondaryColor ;
		// Ter
		Color _ternaryColor ;

		// Hovering
		Color _hoverColor ;

		// Texte
		Color _textColor ;
	} ;
}

/// Class ------------------------------------

namespace nkWinUi
{
	class DLL_WINUI_EXPORT Theme final
	{
		private :

			// Le nom du thème pour l'identifier
			std::string _name ;

			// Le système de couleurs qu'il utilise
			ThemeColors _colors ;

		public :
	
			// Constructeur, destructeur
			Theme () ;
			~Theme () ;

			// Getters
			const char* getName () const ;
			ThemeColors& getColors () ;
			const ThemeColors& getColors () const ;

			// Setters
			void setName (const char* name) ;			
	} ;
}